int HV_Switch_P = A0;
int HV_Switch_N = A1;
int HV_Enable_P = A2;
int HV_Enable_N = A3;
int voltage_in = analogRead(A4);
float voltage = 0.0;

void setup(){
  pinMode(HV_Switch_P, OUTPUT);
  pinMode(HV_Switch_N, OUTPUT);
  pinMode(HV_Enable_P, OUTPUT);
  pinMode(HV_Enable_N, OUTPUT);

  digitalWrite(HV_Switch_P, LOW);
  digitalWrite(HV_Switch_N, LOW);
  digitalWrite(HV_Enable_P, HIGH);
  digitalWrite(HV_Enable_N, HIGH);

  Serial.begin(9600);
  Serial.setTimeout(5); 
  Serial.println("Input 1 for ENABLE +HV, 2 for ENABLE -HV, 3 for DISABLE");
}

void loop() {
  if (Serial.available()){
    int state = Serial.parseInt();

    switch(state){

      case 1:
        // POSITIVE TRANSITION CYCLE
        // DISABLE BOTH HV SUPPLIES, THEN APPLY FALL TIME DELAY FOR TRANSITION SWITCHING
        digitalWrite(HV_Enable_P, HIGH);
        digitalWrite(HV_Enable_N, HIGH);
        delay(1000);
        
        // ACTUATE -HV SWITCH OFF FIRST, THEN +HV SWITCH ON
        digitalWrite(HV_Switch_N, LOW);
        digitalWrite(HV_Switch_P, HIGH);
        Serial.println("+HV TRANSITION! ");
        delay(1000);
//-----------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------
        while(state == 1){
        int state = Serial.parseInt();
        
        // +HV ON CYCLE
        // MAKE SURE -HV IS DISABLED FIRST, THEN ENABLE +HV
        digitalWrite(HV_Enable_N, HIGH);
        digitalWrite(HV_Enable_P, LOW);
        Serial.println("HV+ ON! ");
//-----------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------
        // BREAK CASE CHECK FOR THRUSTER DISABLE         
          if(state == 3){
            digitalWrite(HV_Enable_P, HIGH);
            digitalWrite(HV_Enable_N, HIGH);
            delay(50);
            digitalWrite(HV_Switch_P, LOW);
            digitalWrite(HV_Switch_N, LOW);
            Serial.println("SYSTEM DISABLED!");
            delay(20);
            break;
          }
        }
//-----------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------        
      
      case 2:
//-----------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------
        // NEGATIVE TRANSITION CYCLE
        // DISABLE BOTH HV SUPPLIES, THEN APPLY FALL TIME DELAY FOR TRANSITION SWITCHING
        digitalWrite(HV_Enable_N, HIGH);
        digitalWrite(HV_Enable_P, HIGH);
        delay(1000);

        // ACTUATE +HV SWITCH OFF FIRST, THEN -HV SWITCH ON
        digitalWrite(HV_Switch_P, LOW);
        digitalWrite(HV_Switch_N, HIGH);
        Serial.println("-HV TRANSITION! ");
        delay(1000);
//-----------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------
        while(state == 2){
        int state = Serial.parseInt();

        // -HV ON CYCLE
        // MAKE SURE +HV IS DISABLED FIRST, THEN ENABLE -HV
        digitalWrite(HV_Enable_P, HIGH);
        digitalWrite(HV_Enable_N, LOW);
        Serial.println("HV- ON! ");
//-----------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------
        // BREAK CASE CHECK FOR THRUSTER DISABLE         
          if(state == 3){
            digitalWrite(HV_Enable_P, HIGH);
            digitalWrite(HV_Enable_N, HIGH);
            delay(50);
            digitalWrite(HV_Switch_P, LOW);
            digitalWrite(HV_Switch_N, LOW);
            Serial.println("SYSTEM DISABLED!");
            delay(20);
            break;
          }
        }
//-----------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------      
      
      case 3:
        digitalWrite(HV_Enable_P, HIGH);
        digitalWrite(HV_Enable_N, HIGH);
        delay(50);
        digitalWrite(HV_Switch_P, LOW);
        digitalWrite(HV_Switch_N, LOW);
        Serial.println("SYSTEM DISABLED!");
        delay(20);
        break;
    }
  }
}
